Project Chrono: chrono::vehicle::ChWheel Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
chrono::vehicle::ChWheel Class Referenceabstract
VEHICLE module » Wheeled vehicles » Wheel subsystem

## Description

Base class for a vehicle wheel subsystem.

A wheel subsystem does not own a body. Instead, when attached to a suspension subsystem, the wheel's mass properties are used to update those of the spindle body owned by the suspension. A concrete wheel subsystem can optionally carry its own visualization assets (which are associated with the suspension's spindle body).

`#include <ChWheel.h>`

Inheritance diagram for chrono::vehicle::ChWheel:
[legend]
Collaboration diagram for chrono::vehicle::ChWheel:
[legend]

## Public Member Functions
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual double | GetRadius () const
| Get the wheel radius (for visualization only).
virtual double | GetWidth () const
| Get the wheel width (for visualization only).
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, std::shared_ptr< ChBody > spindle, VehicleSide side, double offset=0)
| Initialize this wheel subsystem by associating it to an existing spindle of a suspension subsystem.
void | EnableCollision (bool state)
| Enable/disable contact for the wheel.
void | Synchronize ()
| Synchronize the wheel subsystem.
void | Synchronize (const TerrainForce &tire_force)
| Synchronize the wheel subsystem.
std::shared_ptr< ChTire > | GetTire () const
| Get the tire attached to this wheel.
void | SetTire (std::shared_ptr< ChTire > tire)
| Associate the given tire with this wheel.
std::shared_ptr< ChBody > | GetSpindle () const
| Get the associated spindle body.
VehicleSide | GetSide () const
| Get the vehicle side on which this wheel is mounted.
ChVector3d | GetPos () const
| Get wheel position (expressed in absolute frame).
WheelState | GetState () const
| Get the current state for this wheel.
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the wheel subsystem.
virtual void | RemoveVisualizationAssets () override
| Remove visualization assets for the wheel subsystem.
const std::string & | GetMeshFilename () const
| Get the name of the Wavefront file with wheel visualization mesh.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const
| Output data for this subsystem's component list to the specified database.

## Protected Member Functions
| ChWheel (const std::string &name)
| Construct a wheel subsystem with given name.
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
virtual double | GetWheelMass () const =0
virtual const ChVector3d & | GetWheelInertia () const =0
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Protected Attributes
std::shared_ptr< ChBody > | m_spindle
| associated suspension spindle body
std::shared_ptr< ChTire > | m_tire
| attached tire subsystem
VehicleSide | m_side
| wheel mounted on left/right side
double | m_offset
| offset from spindle center
std::string | m_vis_mesh_file
| visualization mesh file (may be empty)
std::shared_ptr< ChVisualShapeTriangleMesh > | m_trimesh_shape
| visualization mesh asset
std::shared_ptr< ChVisualShape > | m_cyl_shape
| visualization cylinder asset
std::shared_ptr< ChLoadBodyForce > | m_spindle_terrain_force
| terrain force loads on the spindle
std::shared_ptr< ChLoadBodyTorque > | m_spindle_terrain_torque
| terrain torque loads on the spindle
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Friends
class | ChTire
class | ChWheeledVehicle
class | ChTireTestRig

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Function Documentation

## ◆ AddVisualizationAssets()

void chrono::vehicle::ChWheel::AddVisualizationAssets | ( | VisualizationType | vis | ) |
| overridevirtual

Add visualization assets for the wheel subsystem.

This default implementation uses primitives.

Reimplemented from chrono::vehicle::ChPart.

Reimplemented in chrono::vehicle::artcar::ARTcar_Wheel.

## ◆ EnableCollision()

void chrono::vehicle::ChWheel::EnableCollision | ( | bool | state | ) |
| inline

Enable/disable contact for the wheel.

This function controls contact of the wheel with all other collision shapes in the simulation. Must be called after initialization and has effect only if the derived object has defined some collision shapes.

## ◆ GetMeshFilename()

const std::string & chrono::vehicle::ChWheel::GetMeshFilename | ( |  | ) | const
| inline

Get the name of the Wavefront file with wheel visualization mesh.

An empty string is returned if no mesh was specified.

## ◆ GetRadius()

virtual double chrono::vehicle::ChWheel::GetRadius | ( |  | ) | const
| inlinevirtual

Get the wheel radius (for visualization only).

Reimplemented in chrono::vehicle::artcar::ARTcar_Wheel, chrono::vehicle::bmw::BMW_E90_FrontWheel, chrono::vehicle::bmw::BMW_E90_RearWheel, chrono::vehicle::citybus::CityBus_Wheel, chrono::vehicle::duro::Duro_Wheel, chrono::vehicle::feda::FEDA_Wheel, chrono::vehicle::fmtv::FMTV_Wheel, chrono::vehicle::gator::Gator_Wheel, chrono::vehicle::gclass::G500_Wheel, chrono::vehicle::generic::Generic_Wheel, chrono::vehicle::hmmwv::HMMWV_Wheel, chrono::vehicle::jeep::Cherokee_Wheel, chrono::vehicle::kraz::Kraz_tractor_Wheel, chrono::vehicle::kraz::Kraz_trailer_Wheel, chrono::vehicle::man::MAN_5t_Wheel, chrono::vehicle::mrole::mrole_Wheel, chrono::vehicle::sedan::Sedan_Wheel, chrono::vehicle::uaz::UAZBUS_Wheel, chrono::vehicle::unimog::U401_Wheel, and chrono::vehicle::Wheel.

## ◆ GetState()

WheelState chrono::vehicle::ChWheel::GetState | ( |  | ) | const

Get the current state for this wheel.

This includes the location, orientation, linear and angular velocities, all expressed in the global reference frame, as well as the wheel angular speed about its rotation axis.

## ◆ GetTemplateName()

virtual std::string chrono::vehicle::ChWheel::GetTemplateName | ( |  | ) | const
| inlineoverridevirtual

Get the name of the vehicle subsystem template.

Implements chrono::vehicle::ChPart.

## ◆ GetWidth()

virtual double chrono::vehicle::ChWheel::GetWidth | ( |  | ) | const
| inlinevirtual

Get the wheel width (for visualization only).

Reimplemented in chrono::vehicle::artcar::ARTcar_Wheel, chrono::vehicle::bmw::BMW_E90_FrontWheel, chrono::vehicle::bmw::BMW_E90_RearWheel, chrono::vehicle::citybus::CityBus_Wheel, chrono::vehicle::duro::Duro_Wheel, chrono::vehicle::feda::FEDA_Wheel, chrono::vehicle::fmtv::FMTV_Wheel, chrono::vehicle::gator::Gator_Wheel, chrono::vehicle::gclass::G500_Wheel, chrono::vehicle::generic::Generic_Wheel, chrono::vehicle::hmmwv::HMMWV_Wheel, chrono::vehicle::jeep::Cherokee_Wheel, chrono::vehicle::kraz::Kraz_tractor_Wheel, chrono::vehicle::kraz::Kraz_trailer_Wheel, chrono::vehicle::man::MAN_5t_Wheel, chrono::vehicle::mrole::mrole_Wheel, chrono::vehicle::sedan::Sedan_Wheel, chrono::vehicle::uaz::UAZBUS_Wheel, chrono::vehicle::unimog::U401_Wheel, and chrono::vehicle::Wheel.

## ◆ Initialize()

void chrono::vehicle::ChWheel::Initialize | ( | std::shared_ptr< ChChassis > | chassis,
|  | std::shared_ptr< ChBody > | spindle,
|  | VehicleSide | side,
|  | double | offset = 0 )
| virtual

Initialize this wheel subsystem by associating it to an existing spindle of a suspension subsystem.

The optional 'offset' argument allows models with double wheels(tires). The default value offset=0 corresponds to an axle with a single tire. A positive offset corresponds to an "outer" wheel, while a negative offset corresponds to an "inner" wheel. The wheel mass and inertia are used to increment those of the associated spindle body.

Parameters

  chassis | chassis vehicle (may be null)
  spindle | associated suspension spindle body
  side | wheel mounted on left/right side
  offset | offset from associated spindle center

Reimplemented in chrono::vehicle::generic::Generic_Wheel, chrono::vehicle::hmmwv::HMMWV_Wheel, and chrono::vehicle::jeep::Cherokee_Wheel.

## ◆ InitializeInertiaProperties()

void chrono::vehicle::ChWheel::InitializeInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Initialize subsystem inertia properties.

Derived classes must override this function and set the subsystem mass (m_mass) and, if constant, the subsystem COM frame and its inertia tensor. This function is called during initialization of the vehicle system.

Implements chrono::vehicle::ChPart.

## ◆ RemoveVisualizationAssets()

void chrono::vehicle::ChWheel::RemoveVisualizationAssets | ( |  | ) |
| overridevirtual

Remove visualization assets for the wheel subsystem.

Reimplemented from chrono::vehicle::ChPart.

Reimplemented in chrono::vehicle::artcar::ARTcar_Wheel.

## ◆ Synchronize() [1/2]

void chrono::vehicle::ChWheel::Synchronize | ( |  | ) |

Synchronize the wheel subsystem.

This version queries the forces from the attached tire and applies them to the associated suspension.

## ◆ Synchronize() [2/2]

void chrono::vehicle::ChWheel::Synchronize | ( | const TerrainForce & | tire_force | ) |

Synchronize the wheel subsystem.

This version uses the provided forces as external applied tire/terrain forces.

## ◆ UpdateInertiaProperties()

void chrono::vehicle::ChWheel::UpdateInertiaProperties | ( |  | ) |
| overrideprotectedvirtual

Update subsystem inertia properties.

Derived classes must override this function and set the global subsystem transform (m_xform) and, unless constant, the subsystem COM frame (m_com) and its inertia tensor (m_inertia). Calculate the current inertia properties and global frame of this subsystem. This function is called every time the state of the vehicle system is advanced in time.

Implements chrono::vehicle::ChPart.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/ChWheel.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/ChWheel.cpp